# Aspecto::Opentelemetry

Aspecto's SDK for ruby. This gem is a distribution of Opentelemetry configured to use all available instrumentations and export trace data to Aspecto.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'aspecto-opentelemetry'
```

And then execute:

    $ bundle install

Or install it yourself as:

    $ gem install aspecto-opentelemetry

## Usage

### Auto Instrumentation

Does not require code changes. Just modify you `Gemfile` to add `require` like this:

```
gem 'aspecto-opentelemetry', require: 'aspecto/auto_instrument'
```

When using auto-instrumentation, you need to pass relevant configuration options via environment variables.

### Manual Instrumentation

Allow you to configure the SDK via code:

```rb
require 'aspecto/opentelemetry'

Aspecto::Opentelemetry::configure
```

Add this code at the beginning of your application.
For rails - add this code to a file `aspecto.rb` under `config/initializers/`.

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake test` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and the created tag, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/aspecto-io/aspecto-opentelemetry-ruby.
